Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## weka.classifiers.meta
Class Stacking

    java.lang.Object
      weka.classifiers.Classifier
          weka.classifiers.MultipleClassifiersCombiner
              weka.classifiers.RandomizableMultipleClassifiersCombiner
                  weka.classifiers.meta.Stacking

All Implemented Interfaces:
  java.io.Serializable, java.lang.Cloneable, OptionHandler, Randomizable

Direct Known Subclasses:
  Grading, StackingC

    public class Stacking

extends RandomizableMultipleClassifiersCombiner

Implements stacking. For more information, see

David H. Wolpert (1992). Stacked generalization. Neural Networks, 5:241-259, Pergamon Press.

Valid options are:

-X num_folds
The number of folds for the cross-validation (default 10).

-S seed
Random number seed (default 1).

-B classifierstring
Classifierstring should contain the full class name of a base scheme followed by options to the classifier. (required, option should be used once for each classifier).

-M classifierstring
Classifierstring for the meta classifier. Same format as for base classifiers. (required)

Version:
  $Revision: 1.23.2.1 $
Author:
  Eibe Frank (eibe@cs.waikato.ac.nz)
See Also:
  Serialized Form

Constructor Summary
`Stacking()`

Method Summary
`void` | `buildClassifier(Instances data)` Buildclassifier selects a classifier from the set of classifiers by minimising error on the training data.
`double[]` | `distributionForInstance(Instance instance)` Returns class probabilities.
`Classifier` | `getMetaClassifier()` Gets the meta classifier.
`int` | `getNumFolds()` Gets the number of folds for the cross-validation.
`java.lang.String[]` | `getOptions()` Gets the current settings of the Classifier.
`java.lang.String` | `globalInfo()` Returns a string describing classifier
`java.util.Enumeration` | `listOptions()` Returns an enumeration describing the available options.
`static void` | `main(java.lang.String[] argv)` Main method for testing this class.
`java.lang.String` | `metaClassifierTipText()` Returns the tip text for this property
`java.lang.String` | `numFoldsTipText()` Returns the tip text for this property
`void` | `setMetaClassifier(Classifier classifier)` Adds meta classifier
`void` | `setNumFolds(int numFolds)` Sets the number of folds for the cross-validation.
`void` | `setOptions(java.lang.String[] options)` Parses a given list of options.
`java.lang.String` | `toString()` Output a representation of this classifier

Methods inherited from class weka.classifiers.RandomizableMultipleClassifiersCombiner
`getSeed, seedTipText, setSeed`

Methods inherited from class weka.classifiers.MultipleClassifiersCombiner
`classifiersTipText, getClassifier, getClassifiers, setClassifiers`

Methods inherited from class weka.classifiers.Classifier
`classifyInstance, debugTipText, forName, getDebug, makeCopies, makeCopy, setDebug`

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### Stacking

    public Stacking()

Method Detail

### globalInfo

    public java.lang.String globalInfo()

  Returns a string describing classifier

  Returns:
    a description suitable for displaying in the explorer/experimenter gui

### listOptions

    public java.util.Enumeration listOptions()

  Returns an enumeration describing the available options.

  Specified by:
    `listOptions` in interface `OptionHandler`
  Overrides:
    `listOptions` in class `RandomizableMultipleClassifiersCombiner`
  Returns:
    an enumeration of all the available options.

### setOptions

    public void setOptions(java.lang.String[] options)
                    throws java.lang.Exception

  Parses a given list of options. Valid options are:

  -X num_folds
  The number of folds for the cross-validation (default 10).

  -S seed
  Random number seed (default 1).

  -B classifierstring
  Classifierstring should contain the full class name of a base scheme followed by options to the classifier. (required, option should be used once for each classifier).

  -M classifierstring
  Classifierstring for the meta classifier. Same format as for base classifiers. (default: weka.classifiers.rules.ZeroR)

  Specified by:
    `setOptions` in interface `OptionHandler`
  Overrides:
    `setOptions` in class `RandomizableMultipleClassifiersCombiner`
  Parameters:
    `options` - the list of options as an array of strings
  Throws:
    `java.lang.Exception` - if an option is not supported

### getOptions

    public java.lang.String[] getOptions()

  Gets the current settings of the Classifier.

  Specified by:
    `getOptions` in interface `OptionHandler`
  Overrides:
    `getOptions` in class `RandomizableMultipleClassifiersCombiner`
  Returns:
    an array of strings suitable for passing to setOptions

### numFoldsTipText

    public java.lang.String numFoldsTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### getNumFolds

    public int getNumFolds()

  Gets the number of folds for the cross-validation.

  Returns:
    the number of folds for the cross-validation

### setNumFolds

    public void setNumFolds(int numFolds)
                     throws java.lang.Exception

  Sets the number of folds for the cross-validation.

  Parameters:
    `numFolds` - the number of folds for the cross-validation
  Throws:
    `java.lang.Exception` - if parameter illegal

### metaClassifierTipText

    public java.lang.String metaClassifierTipText()

  Returns the tip text for this property

  Returns:
    tip text for this property suitable for displaying in the explorer/experimenter gui

### setMetaClassifier

    public void setMetaClassifier(Classifier classifier)

  Adds meta classifier

  Parameters:
    `classifier` - the classifier with all options set.

### getMetaClassifier

    public Classifier getMetaClassifier()

  Gets the meta classifier.

  Returns:
    the meta classifier

### buildClassifier

    public void buildClassifier(Instances data)
                         throws java.lang.Exception

  Buildclassifier selects a classifier from the set of classifiers by minimising error on the training data.

  Specified by:
    `buildClassifier` in class `Classifier`
  Parameters:
    `data` - the training data to be used for generating the boosted classifier.
  Throws:
    `java.lang.Exception` - if the classifier could not be built successfully

### distributionForInstance

    public double[] distributionForInstance(Instance instance)
                                     throws java.lang.Exception

  Returns class probabilities.

  Overrides:
    `distributionForInstance` in class `Classifier`
  Parameters:
    `instance` - the instance to be classified
  Returns:
    an array containing the estimated membership probabilities of the test instance in each class or the numeric prediction
  Throws:
    `java.lang.Exception` - if instance could not be classified successfully

### toString

    public java.lang.String toString()

  Output a representation of this classifier

  Overrides:
    `toString` in class `java.lang.Object`

### main

    public static void main(java.lang.String[] argv)

  Main method for testing this class.

  Parameters:
    `argv` - should contain the following arguments: -t training file [-T test file] [-c class index]

Overview | Package | Class | Tree | Deprecated | Index | Help | Weka's home
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD